"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from sifflet_sdk.client.api_client import ApiClient, Endpoint as _Endpoint
from sifflet_sdk.client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from sifflet_sdk.client.model.as_code_monitor_dto import AsCodeMonitorDto
from sifflet_sdk.client.model.as_code_workspace_dto import AsCodeWorkspaceDto
from sifflet_sdk.client.model.light_workspace_apply_request_dto import LightWorkspaceApplyRequestDto
from sifflet_sdk.client.model.problem import Problem
from sifflet_sdk.client.model.rule_dto import RuleDto
from sifflet_sdk.client.model.workspace_apply_response_dto import WorkspaceApplyResponseDto


class WorkspaceApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.convert_monitor_to_code_endpoint = _Endpoint(
            settings={
                'response_type': (AsCodeMonitorDto,),
                'auth': [
                    'JWT'
                ],
                'endpoint_path': '/ui/v1/rules/_convert-to-code',
                'operation_id': 'convert_monitor_to_code',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'rule_dto',
                ],
                'required': [
                    'rule_dto',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'rule_dto':
                        (RuleDto,),
                },
                'attribute_map': {
                },
                'location_map': {
                    'rule_dto': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json',
                    'application/x-yaml',
                    'application/problem+json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.delete_workspace_endpoint = _Endpoint(
            settings={
                'response_type': (WorkspaceApplyResponseDto,),
                'auth': [
                    'JWT'
                ],
                'endpoint_path': '/v1/workspaces/{id}',
                'operation_id': 'delete_workspace',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'id',
                    'cascade_delete',
                    'dry_run',
                ],
                'required': [
                    'id',
                ],
                'nullable': [
                ],
                'enum': [
                    'cascade_delete',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('cascade_delete',): {

                        "ALL": "ALL",
                        "MONITORS": "MONITORS",
                        "NONE": "NONE"
                    },
                },
                'openapi_types': {
                    'id':
                        (str,),
                    'cascade_delete':
                        (str,),
                    'dry_run':
                        (bool,),
                },
                'attribute_map': {
                    'id': 'id',
                    'cascade_delete': 'cascadeDelete',
                    'dry_run': 'dryRun',
                },
                'location_map': {
                    'id': 'path',
                    'cascade_delete': 'query',
                    'dry_run': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json',
                    'application/problem+json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.deploy_workspace_endpoint = _Endpoint(
            settings={
                'response_type': (WorkspaceApplyResponseDto,),
                'auth': [
                    'JWT'
                ],
                'endpoint_path': '/v1/workspaces/{id}',
                'operation_id': 'deploy_workspace',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'id',
                    'light_workspace_apply_request_dto',
                    'error_action',
                    'object_track_action',
                    'object_move_action',
                    'object_untrack_action',
                    'dry_run',
                ],
                'required': [
                    'id',
                    'light_workspace_apply_request_dto',
                ],
                'nullable': [
                ],
                'enum': [
                    'error_action',
                    'object_track_action',
                    'object_move_action',
                    'object_untrack_action',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('error_action',): {

                        "ERROR": "ERROR",
                        "FATAL": "FATAL"
                    },
                    ('object_track_action',): {

                        "ERROR": "ERROR",
                        "IGNORE": "IGNORE",
                        "TRACK": "TRACK"
                    },
                    ('object_move_action',): {

                        "ERROR": "ERROR",
                        "IGNORE": "IGNORE",
                        "MOVE": "MOVE"
                    },
                    ('object_untrack_action',): {

                        "ERROR": "ERROR",
                        "IGNORE": "IGNORE",
                        "UNTRACK": "UNTRACK",
                        "DELETE": "DELETE"
                    },
                },
                'openapi_types': {
                    'id':
                        (str,),
                    'light_workspace_apply_request_dto':
                        (LightWorkspaceApplyRequestDto,),
                    'error_action':
                        (str,),
                    'object_track_action':
                        (str,),
                    'object_move_action':
                        (str,),
                    'object_untrack_action':
                        (str,),
                    'dry_run':
                        (bool,),
                },
                'attribute_map': {
                    'id': 'id',
                    'error_action': 'errorAction',
                    'object_track_action': 'objectTrackAction',
                    'object_move_action': 'objectMoveAction',
                    'object_untrack_action': 'objectUntrackAction',
                    'dry_run': 'dryRun',
                },
                'location_map': {
                    'id': 'path',
                    'light_workspace_apply_request_dto': 'body',
                    'error_action': 'query',
                    'object_track_action': 'query',
                    'object_move_action': 'query',
                    'object_untrack_action': 'query',
                    'dry_run': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json',
                    'application/problem+json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.list_workspaces_endpoint = _Endpoint(
            settings={
                'response_type': ([AsCodeWorkspaceDto],),
                'auth': [
                    'JWT'
                ],
                'endpoint_path': '/v1/workspaces',
                'operation_id': 'list_workspaces',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                },
                'attribute_map': {
                },
                'location_map': {
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json',
                    'application/problem+json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    def convert_monitor_to_code(
        self,
        rule_dto,
        **kwargs
    ):
        """Convert a monitor definition to it's as-code equivalent  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.convert_monitor_to_code(rule_dto, async_req=True)
        >>> result = thread.get()

        Args:
            rule_dto (RuleDto):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            AsCodeMonitorDto
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['rule_dto'] = \
            rule_dto
        return self.convert_monitor_to_code_endpoint.call_with_http_info(**kwargs)

    def delete_workspace(
        self,
        id,
        **kwargs
    ):
        """Delete workspace  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_workspace(id, async_req=True)
        >>> result = thread.get()

        Args:
            id (str):

        Keyword Args:
            cascade_delete (str): [optional] if omitted the server will use the default value of "ALL"
            dry_run (bool): [optional] if omitted the server will use the default value of False
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            WorkspaceApplyResponseDto
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['id'] = \
            id
        return self.delete_workspace_endpoint.call_with_http_info(**kwargs)

    def deploy_workspace(
        self,
        id,
        light_workspace_apply_request_dto,
        **kwargs
    ):
        """Deploy workspace  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.deploy_workspace(id, light_workspace_apply_request_dto, async_req=True)
        >>> result = thread.get()

        Args:
            id (str):
            light_workspace_apply_request_dto (LightWorkspaceApplyRequestDto):

        Keyword Args:
            error_action (str): [optional] if omitted the server will use the default value of "ERROR"
            object_track_action (str): [optional] if omitted the server will use the default value of "ERROR"
            object_move_action (str): [optional] if omitted the server will use the default value of "ERROR"
            object_untrack_action (str): [optional] if omitted the server will use the default value of "ERROR"
            dry_run (bool): [optional] if omitted the server will use the default value of False
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            WorkspaceApplyResponseDto
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['id'] = \
            id
        kwargs['light_workspace_apply_request_dto'] = \
            light_workspace_apply_request_dto
        return self.deploy_workspace_endpoint.call_with_http_info(**kwargs)

    def list_workspaces(
        self,
        **kwargs
    ):
        """List workspaces  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_workspaces(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            [AsCodeWorkspaceDto]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        return self.list_workspaces_endpoint.call_with_http_info(**kwargs)
